VERSION 5.00
Begin VB.Form frmDiss 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   Caption         =   "Dissassembly - from &xxxx"
   ClientHeight    =   4995
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9375
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmDiss.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   4995
   ScaleWidth      =   9375
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraPopup 
      BackColor       =   &H00FFFFFF&
      Caption         =   "CPU status"
      Height          =   1335
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   3975
      Begin VB.PictureBox picPopup 
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         Height          =   975
         Left            =   120
         ScaleHeight     =   975
         ScaleWidth      =   3735
         TabIndex        =   1
         Top             =   240
         Width           =   3735
      End
   End
End
Attribute VB_Name = "frmDiss"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Disassembly window...
'
' Project: FileStore [E01S emulator]
' Module : frmDiss (form)
' Status : Loaded as the application commences, but not shown
'          until requested...
'
' Version: 0.00
' Date   : 3rd August 2009
' Started: 14th April 2009
'
' Author : Rick Murray, heyrick1973 -at- yahoo -dot- co -dot- uk
'          http://www.heyrick.co.uk/econet/
'
'
' Licence:
'
'   Copyright 2010 Rick Murray
'
'   Licensed under the EUPL, Version 1.1 ONLY (the "Licence");
'   You may not use this work except in compliance with the Licence.
'
'   You may obtain a copy of the Licence at:
'
'     http://ec.europa.eu/idabc/eupl5
'
'   Unless required by applicable law or agreed to in writing, software
'   distributed under the Licence is distributed on an "AS IS" basis,
'   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
'   implied. See the Licence for the specific language governing
'   permissions and limitations under the Licence.
'
'
'   Rick's note: The EUPL is "compatible" with GPL v2, but *NOT* the more
'                restrictive GPL v3. If you will be involving GPL code
'                in this project, or using some of this code in a GPL
'                project, you should specify the use of ONLY the GPL v2
'                (and not the boilerplate "GPL 2 or any later...").
'

Option Explicit

Private DissBase As Long
Private DissPC As Long
Private DissNext As Long
Private DissLast As Long
Private LineHei As Long


Private Sub Form_Load()
  Me.Left = (Screen.Width - Me.Width) \ 2
  Me.Top = (Screen.Height - Me.Height) \ 2
  
  Me.Cls
  Me.CurrentY = 0
  Me.Print "X"
  LineHei = Me.CurrentY  ' more accurate than TextHeight as it counts linespace
  Me.Cls
  
  Me.fraPopup.Visible = False
End Sub


Private Sub Form_Resize()
  If (Me.WindowState <> vbMinimized) Then
    If (Me.Width < 4785) Then Me.Width = 4785
    If (Me.Height < 2685) Then Me.Height = 2685
    fraPopup.Left = (Me.Width - (Me.fraPopup.Width + 240))
    DoDiss
  End If
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  If (UnloadMode = vbFormControlMenu) Then
    Cancel = 123
    Me.Hide
  End If
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  If (Shift = 0) Then
    ' normal keypresses
    Select Case KeyCode
      Case 33: ' page up
               DissBase = DissBase - 32&
               If (DissBase < 0&) Then DissBase = 0&
               DoDiss
      
      Case 34: ' page down
               DissBase = DissLast
               DoDiss
    
      Case 38: ' cursor up
               DissBase = DissBase - 1&
               If (DissBase < 0&) Then DissBase = 0&
               DoDiss
      
      Case 40: ' cursor down
               DissBase = DissNext
               DoDiss
    
      Case 112: ' F1 - help
                MsgBox "Disassembly window keypresses:" & vbCrLf & vbCrLf & _
                       vbTab & "Cursor Up" & vbTab & "Back one byte" & vbCrLf & _
                       vbTab & "Curson Down" & vbTab & "Forward an instruction" & _
                       vbCrLf & vbTab & "Page Up" & vbTab & vbTab & "Back 32 bytes" & _
                       vbCrLf & vbTab & "Page Down" & vbTab & "Next screen" & _
                       vbCrLf & vbCrLf & _
                       vbTab & "F1" & vbTab & vbTab & "This help" & vbCrLf & _
                       vbTab & "F5" & vbTab & vbTab & "Run (if halted)" & vbCrLf & _
                       vbTab & "F7" & vbTab & vbTab & "Halt (if running)" & vbCrLf & _
                       vbTab & "F8" & vbTab & vbTab & "Step (if halted)" & vbCrLf & _
                       vbCrLf & vbTab & "^D" & vbTab & vbTab & "Realign" & _
                       "disassembly" & vbCrLf & vbTab & "^S" & vbTab & vbTab & _
                       "Toggle CPU status overlay" & vbCrLf & vbCrLf & _
                       "Because 6502 instructions are of variable sizes," & vbCrLf & _
                       "stepping backwards may result in odd disassembly." & vbCrLf & _
                       "You should continue to step back until the code" & vbCrLf & _
                       "'stabilises'. You'll see what I mean...", _
                       vbInformation
    
      Case 116: ' F5 - run
                ExecHalt = False
                frmMain.SetHaltState
      
      Case 118: ' F7 - halt
                ExecHalt = True
                frmMain.SetHaltState
                DoDiss
      
      Case 119: ' F8 - step
                frmMain.DoSingleStep
                DoDiss
    End Select
    
  ElseIf (Shift = vbCtrlMask) Then
    If (KeyCode = 68) Then
      ' ^D, so realign the disassembly
      DoDiss CPU_ReadPC
    ElseIf (KeyCode = 83) Then
      ' ^S, popup status
      fraPopup.Visible = fraPopup.Visible Xor True
      If ((fraPopup.Visible) = True) Then
        fraPopup.Left = (Me.Width - (Me.fraPopup.Width + 240))
        CPU_DissUpdatePopup
      End If
    End If
  End If
End Sub


Public Sub DoDiss(Optional ByVal FromAddr As Long = -1)
  Dim LinePos As Long, ReadFrom As String
  
  If (FromAddr <> -1) Then
    DissBase = FromAddr
  End If
  DissPC = DissBase
  DissNext = -1
  
  Me.Cls
  
  For LinePos = 0 To Me.Height Step LineHei
    DissLast = DissPC
    DissPC = DissPC + CPU_DissFancy(DissPC, Me, LineHei)
    If (DissNext = -1) Then DissNext = DissPC
  Next
  
  ReadFrom = ""
  If (Memory_ReadEPROMLatch = True) Then
    ReadFrom = " - READING FROM EPROM"
  End If
  
  If (Me.fraPopup.Visible = True) Then CPU_DissUpdatePopup
  
  Me.Caption = "Disassembly - from &" & Right$("0000" & Hex$(DissBase), 4) & ReadFrom
End Sub

